/**
  *### Copyright (c) 2018, EDD-STC Development Team (eddstc1984@gmail.com). ######
  *### SPDX-License-Identifier: Apache-2.0 ######
  ********************************************************************************************
  * @file drv_oled.c
  * @version 0.1.0
  * @brief none
  * @details none
  * @warning standard input and output library functions are not recommended. (such as printf and scanf fuctions in <stdio.h>)
  * @bug none
  ********************************************************************************************
  *###Change Logs:
  *     Date        |   Author      |   Notes
  * ----------------|---------------|---------------------------------------------------------
  *     2019-3-15   |   YC          |   the first version
***/


/* Includes --------------------------------------------------------------------------------*/
#include "drv_iic.h"
#include "drv_oled.h"
/** @addtogroup STC_BSP
  * @{
  */
/* Private typedef -------------------------------------------------------------------------*/
/* Private define --------------------------------------------------------------------------*/
/* Private macro ---------------------------------------------------------------------------*/
#define BRIGHTNESS      0xcf
#define X_WIDTH         128
#define Y_WIDTH         64
/* Private variables -----------------------------------------------------------------------*/

static uint8_t set_line = 0;
static uint8_t set_xaxis = 0;

uint8_t code F16x16[] = {0};
uint8_t code F6x8[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00,    ///< sp
    0x00, 0x00, 0x00, 0x2f, 0x00, 0x00,    ///< !
    0x00, 0x00, 0x07, 0x00, 0x07, 0x00,    ///< "
    0x00, 0x14, 0x7f, 0x14, 0x7f, 0x14,    ///< #
    0x00, 0x24, 0x2a, 0x7f, 0x2a, 0x12,    ///< $
    0x00, 0x62, 0x64, 0x08, 0x13, 0x23,    ///< %
    0x00, 0x36, 0x49, 0x55, 0x22, 0x50,    ///< &
    0x00, 0x00, 0x05, 0x03, 0x00, 0x00,    ///< '
    0x00, 0x00, 0x1c, 0x22, 0x41, 0x00,    ///< (
    0x00, 0x00, 0x41, 0x22, 0x1c, 0x00,    ///< )
    0x00, 0x14, 0x08, 0x3E, 0x08, 0x14,    ///< *
    0x00, 0x08, 0x08, 0x3E, 0x08, 0x08,    ///< +
    0x00, 0x00, 0x00, 0xA0, 0x60, 0x00,    ///< ,
    0x00, 0x08, 0x08, 0x08, 0x08, 0x08,    ///< -
    0x00, 0x00, 0x60, 0x60, 0x00, 0x00,    ///< .
    0x00, 0x20, 0x10, 0x08, 0x04, 0x02,    ///< /
    0x00, 0x3E, 0x51, 0x49, 0x45, 0x3E,    ///< 0
    0x00, 0x00, 0x42, 0x7F, 0x40, 0x00,    ///< 1
    0x00, 0x42, 0x61, 0x51, 0x49, 0x46,    ///< 2
    0x00, 0x21, 0x41, 0x45, 0x4B, 0x31,    ///< 3
    0x00, 0x18, 0x14, 0x12, 0x7F, 0x10,    ///< 4
    0x00, 0x27, 0x45, 0x45, 0x45, 0x39,    ///< 5
    0x00, 0x3C, 0x4A, 0x49, 0x49, 0x30,    ///< 6
    0x00, 0x01, 0x71, 0x09, 0x05, 0x03,    ///< 7
    0x00, 0x36, 0x49, 0x49, 0x49, 0x36,    ///< 8
    0x00, 0x06, 0x49, 0x49, 0x29, 0x1E,    ///< 9
    0x00, 0x00, 0x36, 0x36, 0x00, 0x00,    ///< :
    0x00, 0x00, 0x56, 0x36, 0x00, 0x00,    ///< ;
    0x00, 0x08, 0x14, 0x22, 0x41, 0x00,    ///< <
    0x00, 0x14, 0x14, 0x14, 0x14, 0x14,    ///< =
    0x00, 0x00, 0x41, 0x22, 0x14, 0x08,    ///< >
    0x00, 0x02, 0x01, 0x51, 0x09, 0x06,    ///< ?
    0x00, 0x32, 0x49, 0x59, 0x51, 0x3E,    ///< @
    0x00, 0x7C, 0x12, 0x11, 0x12, 0x7C,    ///< A
    0x00, 0x7F, 0x49, 0x49, 0x49, 0x36,    ///< B
    0x00, 0x3E, 0x41, 0x41, 0x41, 0x22,    ///< C
    0x00, 0x7F, 0x41, 0x41, 0x22, 0x1C,    ///< D
    0x00, 0x7F, 0x49, 0x49, 0x49, 0x41,    ///< E
    0x00, 0x7F, 0x09, 0x09, 0x09, 0x01,    ///< F
    0x00, 0x3E, 0x41, 0x49, 0x49, 0x7A,    ///< G
    0x00, 0x7F, 0x08, 0x08, 0x08, 0x7F,    ///< H
    0x00, 0x00, 0x41, 0x7F, 0x41, 0x00,    ///< I
    0x00, 0x20, 0x40, 0x41, 0x3F, 0x01,    ///< J
    0x00, 0x7F, 0x08, 0x14, 0x22, 0x41,    ///< K
    0x00, 0x7F, 0x40, 0x40, 0x40, 0x40,    ///< L
    0x00, 0x7F, 0x02, 0x0C, 0x02, 0x7F,    ///< M
    0x00, 0x7F, 0x04, 0x08, 0x10, 0x7F,    ///< N
    0x00, 0x3E, 0x41, 0x41, 0x41, 0x3E,    ///< O
    0x00, 0x7F, 0x09, 0x09, 0x09, 0x06,    ///< P
    0x00, 0x3E, 0x41, 0x51, 0x21, 0x5E,    ///< Q
    0x00, 0x7F, 0x09, 0x19, 0x29, 0x46,    ///< R
    0x00, 0x46, 0x49, 0x49, 0x49, 0x31,    ///< S
    0x00, 0x01, 0x01, 0x7F, 0x01, 0x01,    ///< T
    0x00, 0x3F, 0x40, 0x40, 0x40, 0x3F,    ///< U
    0x00, 0x1F, 0x20, 0x40, 0x20, 0x1F,    ///< V
    0x00, 0x3F, 0x40, 0x38, 0x40, 0x3F,    ///< W
    0x00, 0x63, 0x14, 0x08, 0x14, 0x63,    ///< X
    0x00, 0x07, 0x08, 0x70, 0x08, 0x07,    ///< Y
    0x00, 0x61, 0x51, 0x49, 0x45, 0x43,    ///< Z
    0x00, 0x00, 0x7F, 0x41, 0x41, 0x00,    ///< [
    0x00, 0x55, 0x2A, 0x55, 0x2A, 0x55,    ///< 55
    0x00, 0x00, 0x41, 0x41, 0x7F, 0x00,    ///< ]
    0x00, 0x04, 0x02, 0x01, 0x02, 0x04,    ///< ^
    0x00, 0x40, 0x40, 0x40, 0x40, 0x40,    ///< _
    0x00, 0x00, 0x01, 0x02, 0x04, 0x00,    ///< '
    0x00, 0x20, 0x54, 0x54, 0x54, 0x78,    ///< a
    0x00, 0x7F, 0x48, 0x44, 0x44, 0x38,    ///< b
    0x00, 0x38, 0x44, 0x44, 0x44, 0x20,    ///< c
    0x00, 0x38, 0x44, 0x44, 0x48, 0x7F,    ///< d
    0x00, 0x38, 0x54, 0x54, 0x54, 0x18,    ///< e
    0x00, 0x08, 0x7E, 0x09, 0x01, 0x02,    ///< f
    0x00, 0x18, 0xA4, 0xA4, 0xA4, 0x7C,    ///< g
    0x00, 0x7F, 0x08, 0x04, 0x04, 0x78,    ///< h
    0x00, 0x00, 0x44, 0x7D, 0x40, 0x00,    ///< i
    0x00, 0x40, 0x80, 0x84, 0x7D, 0x00,    ///< j
    0x00, 0x7F, 0x10, 0x28, 0x44, 0x00,    ///< k
    0x00, 0x00, 0x41, 0x7F, 0x40, 0x00,    ///< l
    0x00, 0x7C, 0x04, 0x18, 0x04, 0x78,    ///< m
    0x00, 0x7C, 0x08, 0x04, 0x04, 0x78,    ///< n
    0x00, 0x38, 0x44, 0x44, 0x44, 0x38,    ///< o
    0x00, 0xFC, 0x24, 0x24, 0x24, 0x18,    ///< p
    0x00, 0x18, 0x24, 0x24, 0x18, 0xFC,    ///< q
    0x00, 0x7C, 0x08, 0x04, 0x04, 0x08,    ///< r
    0x00, 0x48, 0x54, 0x54, 0x54, 0x20,    ///< s
    0x00, 0x04, 0x3F, 0x44, 0x40, 0x20,    ///< t
    0x00, 0x3C, 0x40, 0x40, 0x20, 0x7C,    ///< u
    0x00, 0x1C, 0x20, 0x40, 0x20, 0x1C,    ///< v
    0x00, 0x3C, 0x40, 0x30, 0x40, 0x3C,    ///< w
    0x00, 0x44, 0x28, 0x10, 0x28, 0x44,    ///< x
    0x00, 0x1C, 0xA0, 0xA0, 0xA0, 0x7C,    ///< y
    0x00, 0x44, 0x64, 0x54, 0x4C, 0x44,    ///< z
    0x14, 0x14, 0x14, 0x14, 0x14, 0x14,    ///< horiz lines
};

uint8_t code F8X16[] =
{
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, ///< 0
    0x00, 0x00, 0x00, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x33, 0x30, 0x00, 0x00, 0x00, ///<! 1
    0x00, 0x10, 0x0C, 0x06, 0x10, 0x0C, 0x06, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, ///<" 2
    0x40, 0xC0, 0x78, 0x40, 0xC0, 0x78, 0x40, 0x00, 0x04, 0x3F, 0x04, 0x04, 0x3F, 0x04, 0x04, 0x00, ///<# 3
    0x00, 0x70, 0x88, 0xFC, 0x08, 0x30, 0x00, 0x00, 0x00, 0x18, 0x20, 0xFF, 0x21, 0x1E, 0x00, 0x00, ///<$ 4
    0xF0, 0x08, 0xF0, 0x00, 0xE0, 0x18, 0x00, 0x00, 0x00, 0x21, 0x1C, 0x03, 0x1E, 0x21, 0x1E, 0x00, ///<% 5
    0x00, 0xF0, 0x08, 0x88, 0x70, 0x00, 0x00, 0x00, 0x1E, 0x21, 0x23, 0x24, 0x19, 0x27, 0x21, 0x10, ///<& 6
    0x10, 0x16, 0x0E, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, ///<' 7
    0x00, 0x00, 0x00, 0xE0, 0x18, 0x04, 0x02, 0x00, 0x00, 0x00, 0x00, 0x07, 0x18, 0x20, 0x40, 0x00, ///<( 8
    0x00, 0x02, 0x04, 0x18, 0xE0, 0x00, 0x00, 0x00, 0x00, 0x40, 0x20, 0x18, 0x07, 0x00, 0x00, 0x00, ///<) 9
    0x40, 0x40, 0x80, 0xF0, 0x80, 0x40, 0x40, 0x00, 0x02, 0x02, 0x01, 0x0F, 0x01, 0x02, 0x02, 0x00, ///<* 10
    0x00, 0x00, 0x00, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x1F, 0x01, 0x01, 0x01, 0x00, ///<+ 11
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0xB0, 0x70, 0x00, 0x00, 0x00, 0x00, 0x00, ///<, 12
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, 0x01, ///<- 13
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x30, 0x00, 0x00, 0x00, 0x00, 0x00, ///<. 14
    0x00, 0x00, 0x00, 0x00, 0x80, 0x60, 0x18, 0x04, 0x00, 0x60, 0x18, 0x06, 0x01, 0x00, 0x00, 0x00, ///</ 15
    0x00, 0xE0, 0x10, 0x08, 0x08, 0x10, 0xE0, 0x00, 0x00, 0x0F, 0x10, 0x20, 0x20, 0x10, 0x0F, 0x00, ///<0 16
    0x00, 0x10, 0x10, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x3F, 0x20, 0x20, 0x00, 0x00, ///<1 17
    0x00, 0x70, 0x08, 0x08, 0x08, 0x88, 0x70, 0x00, 0x00, 0x30, 0x28, 0x24, 0x22, 0x21, 0x30, 0x00, ///<2 18
    0x00, 0x30, 0x08, 0x88, 0x88, 0x48, 0x30, 0x00, 0x00, 0x18, 0x20, 0x20, 0x20, 0x11, 0x0E, 0x00, ///<3 19
    0x00, 0x00, 0xC0, 0x20, 0x10, 0xF8, 0x00, 0x00, 0x00, 0x07, 0x04, 0x24, 0x24, 0x3F, 0x24, 0x00, ///<4 20
    0x00, 0xF8, 0x08, 0x88, 0x88, 0x08, 0x08, 0x00, 0x00, 0x19, 0x21, 0x20, 0x20, 0x11, 0x0E, 0x00, ///<5 21
    0x00, 0xE0, 0x10, 0x88, 0x88, 0x18, 0x00, 0x00, 0x00, 0x0F, 0x11, 0x20, 0x20, 0x11, 0x0E, 0x00, ///<6 22
    0x00, 0x38, 0x08, 0x08, 0xC8, 0x38, 0x08, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x00, 0x00, 0x00, 0x00, ///<7 23
    0x00, 0x70, 0x88, 0x08, 0x08, 0x88, 0x70, 0x00, 0x00, 0x1C, 0x22, 0x21, 0x21, 0x22, 0x1C, 0x00, ///<8 24
    0x00, 0xE0, 0x10, 0x08, 0x08, 0x10, 0xE0, 0x00, 0x00, 0x00, 0x31, 0x22, 0x22, 0x11, 0x0F, 0x00, ///<9 25
    0x00, 0x00, 0x00, 0xC0, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x30, 0x30, 0x00, 0x00, 0x00, ///<: 26
    0x00, 0x00, 0x00, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x60, 0x00, 0x00, 0x00, 0x00, ///<; 27
    0x00, 0x00, 0x80, 0x40, 0x20, 0x10, 0x08, 0x00, 0x00, 0x01, 0x02, 0x04, 0x08, 0x10, 0x20, 0x00, ///<< 28
    0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x40, 0x00, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x04, 0x00, ///<= 29
    0x00, 0x08, 0x10, 0x20, 0x40, 0x80, 0x00, 0x00, 0x00, 0x20, 0x10, 0x08, 0x04, 0x02, 0x01, 0x00, ///<> 30
    0x00, 0x70, 0x48, 0x08, 0x08, 0x08, 0xF0, 0x00, 0x00, 0x00, 0x00, 0x30, 0x36, 0x01, 0x00, 0x00, ///<? 31
    0xC0, 0x30, 0xC8, 0x28, 0xE8, 0x10, 0xE0, 0x00, 0x07, 0x18, 0x27, 0x24, 0x23, 0x14, 0x0B, 0x00, ///<@ 32
    0x00, 0x00, 0xC0, 0x38, 0xE0, 0x00, 0x00, 0x00, 0x20, 0x3C, 0x23, 0x02, 0x02, 0x27, 0x38, 0x20, ///<A 33
    0x08, 0xF8, 0x88, 0x88, 0x88, 0x70, 0x00, 0x00, 0x20, 0x3F, 0x20, 0x20, 0x20, 0x11, 0x0E, 0x00, ///<B 34
    0xC0, 0x30, 0x08, 0x08, 0x08, 0x08, 0x38, 0x00, 0x07, 0x18, 0x20, 0x20, 0x20, 0x10, 0x08, 0x00, ///<C 35
    0x08, 0xF8, 0x08, 0x08, 0x08, 0x10, 0xE0, 0x00, 0x20, 0x3F, 0x20, 0x20, 0x20, 0x10, 0x0F, 0x00, ///<D 36
    0x08, 0xF8, 0x88, 0x88, 0xE8, 0x08, 0x10, 0x00, 0x20, 0x3F, 0x20, 0x20, 0x23, 0x20, 0x18, 0x00, ///<E 37
    0x08, 0xF8, 0x88, 0x88, 0xE8, 0x08, 0x10, 0x00, 0x20, 0x3F, 0x20, 0x00, 0x03, 0x00, 0x00, 0x00, ///<F 38
    0xC0, 0x30, 0x08, 0x08, 0x08, 0x38, 0x00, 0x00, 0x07, 0x18, 0x20, 0x20, 0x22, 0x1E, 0x02, 0x00, ///<G 39
    0x08, 0xF8, 0x08, 0x00, 0x00, 0x08, 0xF8, 0x08, 0x20, 0x3F, 0x21, 0x01, 0x01, 0x21, 0x3F, 0x20, ///<H 40
    0x00, 0x08, 0x08, 0xF8, 0x08, 0x08, 0x00, 0x00, 0x00, 0x20, 0x20, 0x3F, 0x20, 0x20, 0x00, 0x00, ///<I 41
    0x00, 0x00, 0x08, 0x08, 0xF8, 0x08, 0x08, 0x00, 0xC0, 0x80, 0x80, 0x80, 0x7F, 0x00, 0x00, 0x00, ///<J 42
    0x08, 0xF8, 0x88, 0xC0, 0x28, 0x18, 0x08, 0x00, 0x20, 0x3F, 0x20, 0x01, 0x26, 0x38, 0x20, 0x00, ///<K 43
    0x08, 0xF8, 0x08, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x3F, 0x20, 0x20, 0x20, 0x20, 0x30, 0x00, ///<L 44
    0x08, 0xF8, 0xF8, 0x00, 0xF8, 0xF8, 0x08, 0x00, 0x20, 0x3F, 0x00, 0x3F, 0x00, 0x3F, 0x20, 0x00, ///<M 45
    0x08, 0xF8, 0x30, 0xC0, 0x00, 0x08, 0xF8, 0x08, 0x20, 0x3F, 0x20, 0x00, 0x07, 0x18, 0x3F, 0x00, ///<N 46
    0xE0, 0x10, 0x08, 0x08, 0x08, 0x10, 0xE0, 0x00, 0x0F, 0x10, 0x20, 0x20, 0x20, 0x10, 0x0F, 0x00, ///<O 47
    0x08, 0xF8, 0x08, 0x08, 0x08, 0x08, 0xF0, 0x00, 0x20, 0x3F, 0x21, 0x01, 0x01, 0x01, 0x00, 0x00, ///<P 48
    0xE0, 0x10, 0x08, 0x08, 0x08, 0x10, 0xE0, 0x00, 0x0F, 0x18, 0x24, 0x24, 0x38, 0x50, 0x4F, 0x00, ///<Q 49
    0x08, 0xF8, 0x88, 0x88, 0x88, 0x88, 0x70, 0x00, 0x20, 0x3F, 0x20, 0x00, 0x03, 0x0C, 0x30, 0x20, ///<R 50
    0x00, 0x70, 0x88, 0x08, 0x08, 0x08, 0x38, 0x00, 0x00, 0x38, 0x20, 0x21, 0x21, 0x22, 0x1C, 0x00, ///<S 51
    0x18, 0x08, 0x08, 0xF8, 0x08, 0x08, 0x18, 0x00, 0x00, 0x00, 0x20, 0x3F, 0x20, 0x00, 0x00, 0x00, ///<T 52
    0x08, 0xF8, 0x08, 0x00, 0x00, 0x08, 0xF8, 0x08, 0x00, 0x1F, 0x20, 0x20, 0x20, 0x20, 0x1F, 0x00, ///<U 53
    0x08, 0x78, 0x88, 0x00, 0x00, 0xC8, 0x38, 0x08, 0x00, 0x00, 0x07, 0x38, 0x0E, 0x01, 0x00, 0x00, ///<V 54
    0xF8, 0x08, 0x00, 0xF8, 0x00, 0x08, 0xF8, 0x00, 0x03, 0x3C, 0x07, 0x00, 0x07, 0x3C, 0x03, 0x00, ///<W 55
    0x08, 0x18, 0x68, 0x80, 0x80, 0x68, 0x18, 0x08, 0x20, 0x30, 0x2C, 0x03, 0x03, 0x2C, 0x30, 0x20, ///<X 56
    0x08, 0x38, 0xC8, 0x00, 0xC8, 0x38, 0x08, 0x00, 0x00, 0x00, 0x20, 0x3F, 0x20, 0x00, 0x00, 0x00, ///<Y 57
    0x10, 0x08, 0x08, 0x08, 0xC8, 0x38, 0x08, 0x00, 0x20, 0x38, 0x26, 0x21, 0x20, 0x20, 0x18, 0x00, ///<Z 58
    0x00, 0x00, 0x00, 0xFE, 0x02, 0x02, 0x02, 0x00, 0x00, 0x00, 0x00, 0x7F, 0x40, 0x40, 0x40, 0x00, ///<[ 59
    0x00, 0x0C, 0x30, 0xC0, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x01, 0x06, 0x38, 0xC0, 0x00, ///< 60
    0x00, 0x02, 0x02, 0x02, 0xFE, 0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x40, 0x7F, 0x00, 0x00, 0x00, ///<] 61
    0x00, 0x00, 0x04, 0x02, 0x02, 0x02, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, ///<^ 62
    0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, ///<_ 63
    0x00, 0x02, 0x02, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, ///<` 64
    0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x19, 0x24, 0x22, 0x22, 0x22, 0x3F, 0x20, ///<a 65
    0x08, 0xF8, 0x00, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x11, 0x20, 0x20, 0x11, 0x0E, 0x00, ///<b 66
    0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x0E, 0x11, 0x20, 0x20, 0x20, 0x11, 0x00, ///<c 67
    0x00, 0x00, 0x00, 0x80, 0x80, 0x88, 0xF8, 0x00, 0x00, 0x0E, 0x11, 0x20, 0x20, 0x10, 0x3F, 0x20, ///<d 68
    0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x1F, 0x22, 0x22, 0x22, 0x22, 0x13, 0x00, ///<e 69
    0x00, 0x80, 0x80, 0xF0, 0x88, 0x88, 0x88, 0x18, 0x00, 0x20, 0x20, 0x3F, 0x20, 0x20, 0x00, 0x00, ///<f 70
    0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x6B, 0x94, 0x94, 0x94, 0x93, 0x60, 0x00, ///<g 71
    0x08, 0xF8, 0x00, 0x80, 0x80, 0x80, 0x00, 0x00, 0x20, 0x3F, 0x21, 0x00, 0x00, 0x20, 0x3F, 0x20, ///<h 72
    0x00, 0x80, 0x98, 0x98, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x3F, 0x20, 0x20, 0x00, 0x00, ///<i 73
    0x00, 0x00, 0x00, 0x80, 0x98, 0x98, 0x00, 0x00, 0x00, 0xC0, 0x80, 0x80, 0x80, 0x7F, 0x00, 0x00, ///<j 74
    0x08, 0xF8, 0x00, 0x00, 0x80, 0x80, 0x80, 0x00, 0x20, 0x3F, 0x24, 0x02, 0x2D, 0x30, 0x20, 0x00, ///<k 75
    0x00, 0x08, 0x08, 0xF8, 0x00, 0x00, 0x00, 0x00, 0x00, 0x20, 0x20, 0x3F, 0x20, 0x20, 0x00, 0x00, ///<l 76
    0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00, 0x20, 0x3F, 0x20, 0x00, 0x3F, 0x20, 0x00, 0x3F, ///<m 77
    0x80, 0x80, 0x00, 0x80, 0x80, 0x80, 0x00, 0x00, 0x20, 0x3F, 0x21, 0x00, 0x00, 0x20, 0x3F, 0x20, ///<n 78
    0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x00, 0x1F, 0x20, 0x20, 0x20, 0x20, 0x1F, 0x00, ///<o 79
    0x80, 0x80, 0x00, 0x80, 0x80, 0x00, 0x00, 0x00, 0x80, 0xFF, 0xA1, 0x20, 0x20, 0x11, 0x0E, 0x00, ///<p 80
    0x00, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x0E, 0x11, 0x20, 0x20, 0xA0, 0xFF, 0x80, ///<q 81
    0x80, 0x80, 0x80, 0x00, 0x80, 0x80, 0x80, 0x00, 0x20, 0x20, 0x3F, 0x21, 0x20, 0x00, 0x01, 0x00, ///<r 82
    0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x33, 0x24, 0x24, 0x24, 0x24, 0x19, 0x00, ///<s 83
    0x00, 0x80, 0x80, 0xE0, 0x80, 0x80, 0x00, 0x00, 0x00, 0x00, 0x00, 0x1F, 0x20, 0x20, 0x00, 0x00, ///<t 84
    0x80, 0x80, 0x00, 0x00, 0x00, 0x80, 0x80, 0x00, 0x00, 0x1F, 0x20, 0x20, 0x20, 0x10, 0x3F, 0x20, ///<u 85
    0x80, 0x80, 0x80, 0x00, 0x00, 0x80, 0x80, 0x80, 0x00, 0x01, 0x0E, 0x30, 0x08, 0x06, 0x01, 0x00, ///<v 86
    0x80, 0x80, 0x00, 0x80, 0x00, 0x80, 0x80, 0x80, 0x0F, 0x30, 0x0C, 0x03, 0x0C, 0x30, 0x0F, 0x00, ///<w 87
    0x00, 0x80, 0x80, 0x00, 0x80, 0x80, 0x80, 0x00, 0x00, 0x20, 0x31, 0x2E, 0x0E, 0x31, 0x20, 0x00, ///<x 88
    0x80, 0x80, 0x80, 0x00, 0x00, 0x80, 0x80, 0x80, 0x80, 0x81, 0x8E, 0x70, 0x18, 0x06, 0x01, 0x00, ///<y 89
    0x00, 0x80, 0x80, 0x80, 0x80, 0x80, 0x80, 0x00, 0x00, 0x21, 0x30, 0x2C, 0x22, 0x21, 0x30, 0x00, ///<z 90
    0x00, 0x00, 0x00, 0x00, 0x80, 0x7C, 0x02, 0x02, 0x00, 0x00, 0x00, 0x00, 0x00, 0x3F, 0x40, 0x40, ///<{ 91
    0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0xFF, 0x00, 0x00, 0x00, ///<| 92
    0x00, 0x02, 0x02, 0x7C, 0x80, 0x00, 0x00, 0x00, 0x00, 0x40, 0x40, 0x3F, 0x00, 0x00, 0x00, 0x00, ///<} 93
    0x00, 0x06, 0x01, 0x01, 0x02, 0x02, 0x04, 0x04, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00, 0x00,  ///<~ 94
};
/* Private function prototypes -------------------------------------------------------------*/
static void oled_delay(void);
static void oled_write_data(uint8_t dat);
static void oled_write_cmd(uint8_t cmd);
/* Exported functions ----------------------------------------------------------------------*/

/// delay 500ms
static void oled_delay(void)
{
    uint8_t i, j, k;

    i = 61;
    j = 204;
    k = 243;

    do
    {
        do
        {
            while (--k);
        } while (--j);
    } while (--i);
}
/// oled write data
static void oled_write_data(uint8_t dat)
{
    iic_start();
    iic_write(0x78);
    iic_write(0x40);
    iic_write(dat);
    iic_stop();
}
/// oled write cmd
static void oled_write_cmd(uint8_t cmd)
{
    iic_start();
    iic_write(0x78);
    iic_write(0x00);
    iic_write(cmd);
    iic_stop();
}
/**
  * @brief oled initial
  * @param none
  * @return none
  */
void init_oled(void)
{
    oled_delay();            ///< Power on must be delayed
    oled_write_cmd(0xae);    ///<Disable display
    oled_write_cmd(0x00);    ///<Set the low column address
    oled_write_cmd(0x10);    ///<Set the high address
    oled_write_cmd(0x40);    ///<Sets the start address map memory to display the start row
    oled_write_cmd(0x81);    ///<Set the contrast register
    oled_write_cmd(BRIGHTNESS);    ///<Set the cell map to around 0Xa0 and vice versa
    oled_write_cmd(0xa1);    ///<Set the cell map to around 0Xa0 and vice versa
    oled_write_cmd(0xc8);    ///<Set the website/line scan direction 0XCO up and down and vice versa C8 is normal
    oled_write_cmd(0xa6);    ///<normal display
    oled_write_cmd(0xa8);    ///<Set reuse rate (1-64)
    oled_write_cmd(0x3f);    
    oled_write_cmd(0xd3);    ///<Set display offset mapped memory counter (00-3f)
    oled_write_cmd(0x00);    ///<Don't shift
    oled_write_cmd(0xd5);    ///<Set the divider/oscillator frequency of the display clock
    oled_write_cmd(0x80);    ///<Component ratio, the clock is set to 100 framerates per second
    oled_write_cmd(0xd9);    ///<Set charging cycle
    oled_write_cmd(0xf1);    ///<Set charging cycle
    oled_write_cmd(0xda);    ///<Sets the pin setting hardware for the component
    oled_write_cmd(0x12);
    oled_write_cmd(0xdb);    ///<The < set vcomh
    oled_write_cmd(0x40);    ///<Wicombe cancels the level set
    oled_write_cmd(0x20);    ///<Set page seek child mode
    oled_write_cmd(0x02);
    oled_write_cmd(0x8d);    ///<Charging pump enabled
    oled_write_cmd(0x14);    ///<Set (ox10) is disabled
    oled_write_cmd(0xa4);    ///<Make the whole display
    oled_write_cmd(0xa6);    ///<Disable reverse display
    oled_write_cmd(0xaf);    ///<Open the panel
    oled_write_cmd(0x00);
    oledCls();               ///<clear
    oledSetPos(0, 0);
}
/**
  * @brief oled set pots
  * @param[in] x: x axis, y: y axis
  * @return none
  */
void oledSetPos(uint8_t x, uint8_t y)
{
    oled_write_cmd(0xb0 + y);                    ///<0~7page
    oled_write_cmd(((x & 0xf0) >> 4) | 0x10);
    oled_write_cmd((x & 0x0f) | 0x01);
}
/**
  * @brief oled fill data
  * @param[in] bmp_dat:the data to fill
  * @return none
  */
void oledFill(uint8_t bmp_dat)
{
    uint8_t y, x;

    for (y = 0; y < 8; y++)
    {
        oled_write_cmd(0xb0 + y);
        oled_write_cmd(0x01);
        oled_write_cmd(0x10);

        for (x = 0; x < X_WIDTH; x++)
        {
            oled_write_data(bmp_dat);
        }
    }
}
/**
  * @brief oled clear
  * @param none
  * @return none
  */
void oledCls(void)
{
    uint8_t y, x;

    for (y = 0; y < 8; y++)
    {
        oled_write_cmd(0xb0 + y);
        oled_write_cmd(0x01);
        oled_write_cmd(0x10);

        for (x = 0; x < X_WIDTH; x++)
        {
            oled_write_data(0);
        }
    }
}
/**
  * @brief oled show 6x8char
  * @param[in] x;xaxis
  * @param[in] y;xaxis
  * @param[in] ch[];string pointer
  * @return none
  */
void oledPlay_6x8str(uint8_t x, uint8_t y, uint8_t ch[])
{
    uint8_t c = 0, i = 0, j = 0;

    while (ch[j] != '\0')
    {
        c = ch[j] - 32;

        if (x > 126)
        {
            x = 0;
            y++;
        }

        oledSetPos(x, y);

        for (i = 0; i < 6; i++)
        {
            oled_write_data(F6x8[c * 6 + i]);
        }

        x += 6;
        j++;
    }
}
/**
  * @brief oled show 8x16char
  * @param[in] x;xaxis
  * @param[in] y;xaxis
  * @param[in] ch[];string pointer
  * @return none
  */
void oledPlay_8x16str(uint8_t x, uint8_t y, uint8_t ch[])
{
    uint8_t c = 0, i = 0, j = 0;

    while (ch[j] != '\0')
    {
        c = ch[j] - 32;

        if (x > 120)
        {
            x = 0;
            y++;
        }

        oledSetPos(x, y);

        for (i = 0; i < 8; i++)
        {
            oled_write_data(F8X16[c * 16 + i]);
        }

        oledSetPos(x, y + 1);

        for (i = 0; i < 8; i++)
        {
            oled_write_data(F8X16[c * 16 + i + 8]);
        }

        x += 8;
        j++;
    }
}
/**
  * @brief oled show 16x16char
  * @param[in] x;xaxis
  * @param[in] y;xaxis
  * @param[in] n;number of char
  * @return none
  */
void oledPlay_16x16char(uint8_t x, uint8_t y, uint8_t n)
{
    uint8_t wm = 0;
    uint16_t adder;
    adder = n * 32;
    oledSetPos(x, y);

    for (wm = 0; wm < 16; wm++)
    {
        oled_write_data(F16x16[adder]);
        adder += 1;
    }

    oledSetPos(x, y + 1);

    for (wm = 0; wm < 16; wm++)
    {
        oled_write_data(F16x16[adder]);
        adder += 1;
    }
}
/**
  * @brief oled draw point
  * @param[in] x0;xaxis
  * @param[in] y0;xaxis
  * @param[in] x1;xaxis
  * @param[in] y1;xaxis
  * @param[in] bmp[] ;bmp pointer
  * @return none
  */
void oledDrawBmp(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1, uint8_t bmp[])
{
    uint8_t x, y;

    for (y = y0; y < y1; y++)
    {
        oledSetPos(x0, y);

        for (x = x0; x < x1; x++)
        {
            oled_write_data(bmp[y * 128 + x]);
        }
    }
}
/**
  * @brief oled draw point
  * @param[in] table; image pointer
  * @param[in] length;image length
  * @param[in] wide;image width
  * @return none
  */
void oledShowCross(uint8_t *table, uint8_t length, uint8_t width)
{
    uint8_t i, x, y;
    uint8_t temp = 0;
    uint8_t store = 0;

    uint8_t line_num;
    uint8_t leap_line;
    uint8_t leap_group;
    uint16_t max_offset; 
    uint16_t current_offset;

    line_num = (width >> 3) + (width % 8 || 0); 
    leap_line = (length >> 3) + (length % 8 || 0);  
    leap_group = leap_line << 3;
    max_offset = leap_line * width;

    for (y = 0; y < line_num; y ++)
	{
		oledSetPos(0, y);
		for (x = 0; x < length; x ++)
        {
            for (i = 0; i < 8; i ++)
            {
                temp = temp >> 1;
                current_offset = i * leap_line + y * leap_group + (x >> 3); 
                if (current_offset >= max_offset)
                    store = 0xff;                                           
                else
                    store = *(table + current_offset);
                temp |= (store << x % 8) & 0x80;
            }
            oled_write_data(~temp);
            temp = 0;
        }
	}
}
/**
  * @brief oled draw point
  * @param[in] x;xaxis
  * @param[in] y;xaxis
  * @param[in] cmd;write cmd
  * @param[in] *p ;bmp pointer
  * @return none
  */
void oledDrawPoint(uint8_t x, uint8_t y, bit cmd, uint8_t *p)
{
    if (cmd == 1)
    {
        p[(y / 8) * 128 + x] |= 0x01 << (y % 8);
    }
    else
    {
        p[(y / 8) * 128 + x] &= ~(0x01 << (y % 8));
    }
}
/**
  * @brief oled clear point
  * @param[in] *p; bmp pointer
  * @return none
  */
void oledCleanPoint(uint8_t *p)
{
    uint16_t i = 0;

    for (i = 0; i < 8 * 128; i++)
    {
        * (p + i) = 0x00;
    }
}

#if OLED_PRINT
/**
  * @brief redirect to oled
  * @param[in] ch;transmit char
  * @return none
  */
uint16_t enter_fputc(uint8_t ch)
{
    oledPrintChar(ch);
    return (ch);
}
/**
  * @brief oled redirect
  * @param[in] ch:transmit char
  * @return none
  */
void oledPrintChar(uint8_t ch)
{
    static uint8_t clean_flag = 0;
    uint8_t temp[2];

    temp[0] = ch;
    temp[1] = '\0';

    if (set_line == 0 && clean_flag == 1)
    {
        clean_flag = 0;
        oledCls();
    }

    if ((ch < ' ' || ch > 'z' + 1) && (ch != '\n') && (ch != '\r') && (ch != '\t'))
    {
        oledPlay_8x16str(0, set_line, " ");
        set_xaxis += 6;
    }
    else if (ch == '\n')
    {
        set_line ++;
        set_xaxis = 0;
    }
    else if (ch == '\r')
    {
        set_xaxis = 0;
    }
    else if (ch == '\t')
    {
        oledPlay_8x16str(0, set_line, "    ");
        set_xaxis += 6 * 4;
    }
    else
    {
        oledPlay_8x16str(set_xaxis, set_line, temp);
        set_xaxis += 6;
    }

    if (set_xaxis >= 128 - 6)
    {
        set_xaxis = 0;
        set_line ++;
    }

    if (set_line > 7)
    {
        set_line = 0;
        clean_flag = 1;
    }
}

/**
  * @brief  used to limit printf to put char in a place
  * @param  line,the line of char
  * @param  xaxis,the xaxis of char
  * @retval None
  */
void printSetLine(uint8_t line, uint8_t xaxis)
{
    set_line = line;
    set_xaxis = xaxis;
}
#endif

/**
  * @}
  */
/************************ (C) COPYRIGHT YC *****END OF FILE*********************************/
